/**
 *
 */
package edu.agh.sm2006.bluetooth;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Form;

/**
 * Performs operations on midlet's form depending on inquiry state
 *
 * @author Kuba Madej
 *
 */
public class DiscoveryState {
	/**
	 * String shown in form's label when searching for devices
	 */
	public final static String SEARCHING = "Searching...";

	/**
	 * String shown in form's label when searching for devices is completed
	 */
	public final static String SEARCH_COMPLETED = "Search completed";

	/**
	 * Midlet's form
	 */
	private Form form;

	/**
	 * Boolean telling wheather serch operation is performed at the moment
	 */
	private boolean searching;

	/**
	 * Start discovery command
	 */
	private Command startDiscoveryCommand;

	/**
	 * Stop discovery command
	 */
	private Command stopDiscoveryCommand;

	/**
	 * The only constructor
	 *
	 * @param form
	 *            midlet's form
	 * @param startDiscoveryCommand
	 *            start doscovery command
	 * @param stopDiscoveryCommand
	 *            stop discovery command
	 */
	public DiscoveryState(Form form, Command startDiscoveryCommand,
			Command stopDiscoveryCommand) {
		this.form = form;
		this.startDiscoveryCommand = startDiscoveryCommand;
		this.stopDiscoveryCommand = stopDiscoveryCommand;
		toogleState();
	}

	/**
	 * Toogles the state. This results in UI changes.
	 *
	 */
	public void toogleState() {
		searching = !searching;
		if (searching) {
			form.deleteAll();
			form.setTitle(SEARCHING);
			form.removeCommand(startDiscoveryCommand);
			form.addCommand(stopDiscoveryCommand);
		} else {
			form.setTitle(SEARCH_COMPLETED);
			form.removeCommand(stopDiscoveryCommand);
			form.addCommand(startDiscoveryCommand);
		}
	}
}
